# ⚠️ Archival Notice ⚠️ 

This project was a part of Neoteric Design's internal tooling and prototypes. 

These are no longer officially supported or maintained, and may contain bugs or be in any stage of (in)completeness.

This repository is provided as a courtesy to our former clients to support their projects going forward, as well in the interest of giving back what we have to the community. If you found yourself here, we hope you find it useful in some capacity ❤️ 


--------------------

# Pubdraft

Publication state management for the Neoteric Design CMS

Mark models as 'published', 'drafted', or whatever you like. Filter out drafted
material from public view.

## Installation

Add pubdraft to your Gemfile

```ruby
# Gemfile
  gem 'pubdraft', "~> 1.1.0"
```

```sh
$ bundle install
```

## Usage

Pubdraft requires a string column on your parent model.

```ruby
class MyModel < ActiveRecord::Base
  pubdraft

  # or

  pubdraft field: :publication_status,
           states: { in_review: :mark_for_review, drafted: :draft },
           default: :in_review
end

record = MyModel.create!
record.published? #=> true

record.draft!
record.drafted?   #=> true

record.publish!
record.published? #=> true

MyModel.published #=> [published records]
MyModel.drafted   #=> [drafted records]
```


### Options

You can customize Pubdraft per model by setting options when calling the `pubdraft` method.

| Option  | Default        | Description                                 |
|---------|----------------|---------------------------------------------|
|`field`  | `'state'`      | Name of the attribute to use to store state |
|`states` | `{ published: :publish, drafted: :draft }`| Hash of states to use. See [States](states)|
|`default`| `'drafted'`  | Default state to set when none is provided. Disable setting a default by setting this to `false` |


### States

When setting up pubdraft on a model, you can supply your own custom set of states. States consist of a name, and an action descriptor. THe name is used as the value of the state, while the action is the natural language verb to put in that state.

```ruby
  class Post < ApplicationRecord
    pubdraft states: {
              # Name        # Action
              published:    :publish,
              drafted:      :draft
              in_review:    :mark_for_review
            }
  end

  @post.publish!
  @post.published?                 #=> true
  Post.published.includes?(@post)  #=> true

  @post.mark_for_review!
  @post.in_review?                 #=> true
  Post.in_review.includes?(@post)  #=> true
```

### View Helpers

The gem provides a view helper to easily populate select boxes. It requires the object's class to read its configured states.

```erb
<!-- Standard Form Helpers -->
<%= form_for @record do |f| %>
  <%= f.select :state, pubdraft_state_options(f.object.class) %>
<% end %>

<!-- Formtastic -->
<%= semantic_form_for @record do |f| %>
  <%= f.input :state, :as => :select,
              :collection => pubdraft_states_for_select(f.object.class) %>
<% end %>
```

## Contributing

### Testing

In the base directory:

```bash
$ rspec
````

